`BGandNorm` <-
function(RGlist,BGmethod=NULL,NORMmethod=NULL,foreground=NULL,background=NULL,
		offset=NULL,makePLOTpre=NULL,makePLOTpost=NULL ){

require(vsn)

	cat("BACKGROUND CORRECTION AND NORMALIZATION ","\n")
	cat("\n")
	if (!is(RGlist, "RGList")){
	  stop("'input' must be a RGList")
   	 	if (is.null(dim(RGlist)[1])) {
        		stop("'input' is empty")
	 	}
	}

	if(missing(BGmethod)){
		BGmethod="none"		
	}else{
		if(BGmethod != "none" && BGmethod != "half" && BGmethod != "normexp"){
			stop("BGmethod should be one of 'none', 'half','normexp' " )	
		}
	}
	if(missing(NORMmethod)){
		NORMmethod="none"		
	}else{
		if(NORMmethod != "none" && NORMmethod != "quantile" && NORMmethod != "vsn"){
		stop("NORMmethod should be one of 'none', 'quantile','vsn' " )	
		}
	}	
	if(missing(foreground)){
		cat("'foreground signal is missing => foreground used is 'MeanSignal'","\n")
		cat("	NORMmethod is set to 'quantile' ","\n")	
		NORMmethod="quantile"	
	}else{
		if(foreground != "ProcessedSignal" && foreground !="MeanSignal" ){
			cat("foreground: ",foreground,"\n")
			stop("'foreground' must be either 'ProcessedSignal' or 'MeanSignal'")	
		}else{ 
			if(foreground == "ProcessedSignal"){
	  			RGlist$G=RGlist$R
	  			cat("	foreground: ProcessedSignal","\n")
			}else{
				cat("	foreground: MeanSignal","\n")
			}	
		}		
	}

	if(missing(background)){
		cat("'background signal is missing => BGmethod is set to 'none'")
		BGmethod="none"
	}else{
			
		if(background != "BGMedianSignal" && background !="BGUsed" ){
			cat("background: ",background,"\n")
			stop("'background' must be either 'BGMedianSignal' or 'BGUsed'")	
		}else{ 

			if(background == "BGMedianSignal"){
	  			RGlist$Gb=RGlist$Rb
	  			cat("	background: BGMedianSignal","\n")
			}else{
				cat("	background: BGUsed","\n")
			}
		}
	}

	if(missing(offset)){
		offset=0
	}

	# CONTROL NAS
	p=c(1:dim(RGlist)[2])
	controlNA=length(which(is.na(RGlist$G[,p])==TRUE))
	if(controlNA >0){
		cat("# NAs in RGlist$G - ",controlNA,"\n")
	  	stop("program will stop now")
	}
	

	if(!missing(makePLOTpre)) {
	if(makePLOTpre){
	
	ddaux=RGlist
	ddaux$G=log2(ddaux$G)

	colorfill="blue"

	
	maintitle="RAW SIGNAL"
	MMM=ddaux$G

		X11()
		par(mfrow=c(1,1))
		plotDensity(MMM,maintitle)

		X11()
		par(mfrow=c(1,1))
		boxplotNegCtrl(ddaux,Log2=TRUE) 

		X11()
		par(mfrow=c(1,1),ask=T)
		MVAplotMEDctrl(ddaux,maintitle) 

		maintitle="RAW DATA - RLE "
		X11()
		par(mfrow=c(1,1))
		RLE(MMM,maintitle,colorfill)

		rm(MMM)
		rm(ddaux)
	}
	}


	if(BGmethod != "none"){
		ddBG=backgroundCorrect(RGlist,method=BGmethod,offset=offset) 
	}else{
		ddBG=RGlist 
	}

	if(NORMmethod != "none"){
		ddNORM=RGlist
		exprsNORM=normalizeBetweenArrays(ddBG$G,method=NORMmethod) 
			if(NORMmethod == "quantile"){
				ddNORM$G=log2(exprsNORM)
			}else{
				ddNORM$G=exprsNORM
			}
		rm(exprsNORM)

	}else{
		ddNORM=ddBG
		ddNORM$G=log2(RGlist$G)
		 
	}

	cat("\n")
	cat("	BGmethod:	",BGmethod,"\n")
	cat("	NORMmethod:	",NORMmethod,"\n")
	cat("	OUTPUT in log-2 scale","\n")
	cat("\n")
	cat("------------------------------------------------------","\n")

	if(!missing(makePLOTpost)) {
	if(makePLOTpost){
	colorfill="red"

	maintitle="NORMALIZED SIGNAL"
	MMM=ddNORM$G

		X11()
		par(mfrow=c(1,1))
		plotDensity(MMM,maintitle)

		X11()
		par(mfrow=c(1,1))
		boxplotNegCtrl(ddNORM,Log2=TRUE) 

		X11()
		par(mfrow=c(1,1),ask=T)
		MVAplotMEDctrl(ddNORM,maintitle) 


		maintitle="NORMALIZED DATA - RLE "
		X11()
		par(mfrow=c(1,1))
		RLE(MMM,maintitle,colorfill)

		rm(MMM)
	}
	}

return(ddNORM)

} # end function 

