`CV.rep.probes` <-
function(ddDUP,annotation.package,foreground,raw.data,writeR,targets){

#require(hgug4112a.db)
#require(mgug4122a.db)

	if (!is(ddDUP, "RGList")){
	  stop("'input' must be a RGList")
   	 	if (is.null(dim(ddDUP)[1])) {
        		stop("'input' is empty")
	 	}
	}

	if(missing(annotation.package)) {
                stop("A known'annotation.package' is needed ")
        }else{
                if(annotation.package =="notAnnPack"){
                	stop("A known'annotation.package' is needed ")
                }
        }

	if(foreground != "ProcessedSignal" && foreground !="MeanSignal" ){
		cat("foreground: ",foreground,"\n")
		stop("'foreground' must be either 'ProcessedSignal' or 'MeanSignal'")	
	}else{ 
		if(foreground == "ProcessedSignal"){
	  		ddDUP$G=ddDUP$R
		}
	}

	if(missing(raw.data)){
		stop("'raw.data' has to be specified")	
	}else{
	  if(raw.data){
		ddDUP$G=log2(ddDUP$G)
			filter.control=T
	 	}else{
			filter.control=F
		}
	}	

	 if(filter.control){
		# ControlType: 0 = signal, +1 = C.pos, -1 = C.neg (56)
		selSNR=which(ddDUP$genes$ControlType ==0)
 		ddDUP=ddDUP[selSNR,]
 		nGEN=dim(ddDUP)[1]
		cat("\n")
		cat("------------------------------------------------------","\n")
		cat("Non-CTRL Replicated probes","\n")
		cat("	foreground: ",foreground,"\n")
 		cat("		FILTERING BY ControlType FLAG","\n")
		cat("		RAW DATA: PROBES AFTER ControlType FILTERING: ",nGEN,"\n")
		cat("\n")
		
	 }
	
	if(missing(writeR)){
		writeR=FALSE
	}
		dup=which(duplicated(ddDUP$genes$ProbeName)==TRUE)
		if(length(dup) == 0){
		stop("NOT DUPLICATED ProbeName in chip")
			} 

	uni=unique(ddDUP$genes$ProbeName)

	Ldup=length(dup)   
	Luni=length(uni) 

	reps=table(ddDUP$genes$ProbeName[dup])
	# reps[]=reps[]+1
	t=table(reps)

	rN=names(reps)
	Lreps=length(rN)

	GENE_ID= unlist(lookUp(rN,annotation.package,"ACCNUM") )
	gene.sym=unlist(lookUp(rN,annotation.package,"SYMBOL") )
	gene.des=unlist(lookUp(rN,annotation.package,"GENENAME") )
	nch=nchar(gene.des)
	gene.des=substr(gene.des,1,60)
	gene.des=paste(gene.des,ifelse(nch > 60, "...",""),sep="")

		cat("------------------------------------------------------","\n")
		cat("	REPLICATED NonCtrl Probes",Lreps,"\n")
		cat("	UNIQUE probes",Luni,"\n")
		cat("	DISTRIBUTION OF REPLICATED NonControl Probes","\n")
		print(t)
		cat("	# REPLICATED (redundant) probeNames",Ldup,"\n")
		cat("------------------------------------------------------","\n")

	nARR=dim(ddDUP)[2]
	cvmat=matrix(ncol=nARR,nrow=Lreps)
	colnames(cvmat)=rownames(targets) 
	rownames(cvmat)=rN

 	for(i in 1:Lreps){
  		index=which(ddDUP$genes$ProbeName==rN[i])

  	# CV: sd/m 
  		# computo CV para cada subconjnto
  		# de reps  por COLS (arrays)
  		# MIRAMOS GEN A GEN, EN TODOS ARRAYS !!!

  	sd=round(apply(ddDUP$G[index,],2,sd),2)
  	m=round(apply(ddDUP$G[index,],2,mean),2)
  	cv=(sd/m)*100
  	cvmat[i,]=cv
  
 	}

	cvMedARR=round(apply(cvmat,2,median),3)

	if(writeR) {
		result=data.frame(rN,reps[],GENE_ID,gene.sym,gene.des,round(cvmat,3))
		colnames(result)=c("PROBE        ","n Rep","ACCNUM","SYMBOL","DESCRIPTION",rownames(targets))
		write.table(result,file="Probe.Sets.txt",row.names=F,col.names = TRUE,
			quote=F,dec=".",eol = "\n",sep = "\t")
	}

	maintitle="% CV replicated Non-Controls"
	colorfill="lightblue"

		X11()
		par(mfrow=c(1,1))
			BoxPlot(cvmat,maintitle,colorfill,xlab="Samples",ylab="CV %")


	cat("MEDIAN % CV","\n")
	print(cvMedARR)
	cat("------------------------------------------------------","\n")

} # end function 

