`MVAplotMEDctrl` <-
function(RGlist,maintitle,channel=NULL) {

#cat("\n")
#cat("------------------------------------------------------","\n")
#cat("MVAplotMEDctrl info:","\n")

if (!missing(channel)){
	if(channel == "R"){
	  RGlist$G=RGlist$R
	  # cat("channel: RGlist$R","\n")

	}
}else{
	 # cat("channel: RGlist$G","\n")
}

nGEN=c(1:dim(RGlist$G)[1])

# ------------------ REP NonCtrl --------------------
index1=which(duplicated(RGlist$genes$ProbeName)==TRUE)
index2=which(RGlist$genes$ControlType[index1] == 0)

indexrep=nGEN[index1[index2]]

# p=RGlist$genes$ControlType[indexrep]
# p=RGlist$genes$ProbeName[indexrep]

LL=length(indexrep)
# cat("	REPLICATED NON-CTRL:	",LL,"\n")

# ------------------ POS Ctrl --------------------
index1=which(RGlist$genes$ControlType == 1)
index2=which(RGlist$genes$GeneName[index1] != "DarkCorner")
index3=which(RGlist$genes$GeneName[index1[index2]] != "GE_BrightCorner")

indexpos=nGEN[index1[index2[index3]]]

# p=RGlist$genes$ControlType[indexpos]

LL=length(indexpos)
# cat("	POSITIVE CTRL:		",LL,"\n")

# ------------------ NEG Ctrl --------------------
indexneg=which( RGlist$genes$ControlType == -1)

LL=length(indexneg)
# cat("	NEGATIVE CTRL:		",LL,"\n")
# ------------------ STRUCTURAL  --------------------

indexDC=which(RGlist$genes$GeneName == "DarkCorner" )
indexGE=which(RGlist$genes$GeneName == "GE_BrightCorner")

LL=length(indexDC)+length(indexGE)
# cat("	STRUCTURAL:		",LL,"\n")

# cat("------------------------------------------------------","\n")

nARR=dim(RGlist$G)[2]
RGlist$G=log2(RGlist$G)
y=apply(RGlist$G,1,median)

for(i in 1:nARR) {

if (!missing(maintitle)){
what=paste(maintitle,"-",colnames(RGlist$G)[i]," - ","genewise Median")
}else{
what=paste(colnames(RGlist$G)[i]," - ","genewise Median")
}
	
        x=RGlist$G[,i]
	A=(x+y)/2
	M=(x-y)
        mva=plot(A,M,type="p",cex=0.7,col="blue",xlab="A",ylab="M")

        points(A[indexrep],M[indexrep],cex=0.3,col="cyan",pch=19)   	# Rep NonCtrl 
        points(A[indexDC],M[indexDC],cex=0.5,col="orange",pch=19)   	# DarkCorner  
        points(A[indexpos],M[indexpos],cex=0.3,col="red",pch=19)   	# pos Ctrl 
        points(A[indexneg],M[indexneg],cex=0.4,col="green",pch=19)   	# neg Ctrl 
        points(A[indexGE],M[indexGE],cex=1.0,col="yellow",pch=19)   	# GE_BrightCorner 

        title(main=what)
        abline(0,0,col="black",lty=2, lwd=1)
        abline(2,0,col="navyblue")
        abline(-2,0,col="navyblue")

colors=c("blue","red","green","cyan","orange","yellow")
samples=c("Genes","Pos Ctrl","Neg Ctrl","Rep NonCtrl","DarkCorner","GE_BrightCorner")
legend(x = "topright", legend = samples, cex = 0.8,fill = colors, inset = 0.05)

}

} # end function

