`boxplotNegCtrl` <-
function(RGlist,Log2,channel) {

if (missing(Log2)){
Log2=FALSE 
}

if (!missing(channel)){
	if(channel == "R"){
	  RGlist$G=RGlist$R
	  # cat("channel: RGlist$R","\n")
	}
}else{
	# cat("channel: RGlist$G","\n")
}

# ------------------ NEG Ctrl --------------------
indexneg=which( RGlist$genes$ControlType == -1)
  if(Log2){ 
   	NEG=RGlist$G[indexneg,]
  }else{
   	NEG=log2(RGlist$G[indexneg,])
  }

 MeanNeg=apply(NEG,2,mean)
 SdNeg=apply(NEG,2,sd)
 Limit=MeanNeg+ 1.5*(SdNeg)
 CV=(SdNeg/MeanNeg) *100

# cat("	Limit = Mean + 1.5 SD  and CV% for NegCtrl","\n")
# cat("\n")
 aux=rbind(round(Limit,2),round(CV,2))
 rownames(aux)=c("Limit","CV%")
 # print(aux)
 # cat("NEGATIVE CTRL:   ",length(indexneg),"\n")

# ------------------ GENES FEATURES ---------------
  selSNR=which(RGlist$genes$ControlType==0)
 
  if(Log2){ 
  	FEATURES=RGlist$G[selSNR,]
  }else{
  	FEATURES=log2(RGlist$G[selSNR,])
  }
  # cat("GENES:   ", length(selSNR),"\n")

# ---------------------------------------------------
MIN=min(FEATURES,na.rm=T)
MAX=max(FEATURES,na.rm=T)
nARR=dim(RGlist)[2]

	par(las=3)
	plot(Limit,xlim=c(0,nARR+1),ylim=c(MIN,MAX),
	axes=FALSE,xlab="Samples",ylab="exprs")

		boxplot(data.frame(FEATURES),outline=T,add=T,col="red")
		boxplot(data.frame(NEG),outline=T,add=T,col="green")

	points(Limit,type = "p",col = "blue")
	lines(Limit,type = "l",col = "blue",lty = "dotted")
	title(main=" Neg Ctrl & Genes ")
	par(las=0)

} # end function

