`filter.probes` <-
function(ddNORM,control=NULL,wellaboveBG=NULL,isfound=NULL,wellaboveNEG=NULL,
				sat=NULL,PopnOL=NULL,NonUnifOL=NULL,nas=NULL,
				limWellAbove,limISF,limNEG,limSAT,limPopnOL,limNonUnifOL,limNAS,
				makePLOT,annotation.package,flag.counts=NULL,targets){
#require(hgug4112a.db)
#require(mgug4122a.db)

	cat("FILTERING PROBES BY FLAGS","\n")
	cat("\n")

	if (!is(ddNORM, "RGList")){
	  stop("'input' must be a RGList")
   	 	if (is.null(dim(ddNORM)[1])) {
        		stop("'input' is empty")
	 	}
	}

        if(missing(annotation.package)) {
                stop("'annotation.package' is needed ")
        }else{
                if(annotation.package =="notAnnPack"){
		cat("NOT ANNOTATION PACKAGE AVAILABLE AT THIS MOMENT","\n")
			ManuelaGO=FALSE
                }else{
			if (annotation.package %in% .packages(all = TRUE)) {
			} else {
			cat("	R will proceed to install the annotation package:",annotation.package,"\n")
			install.packages(annotation.package)
			} 
		ManuelaGO=TRUE
		}
        }
	
	if(missing(targets)){
		stop("'targets' is missing ")
	}


	if(missing(limWellAbove)){
		limWellAbove=75
			}
	if(missing(limISF)){
		limISF=75.0
			}
	if(missing(limNEG)){
		limNEG=75
			}
	if(missing(limSAT)){
		limSAT=75.0
			}
	if(missing(limPopnOL)){
		limPopnOL=25.0
			}
	if(missing(limNonUnifOL)){
		limNonUnifOL=25.0
			}
	if(missing(limNAS)){
		limNAS=100
			}	

# FILTERING STEPS 


	if(!missing(control)){
	if(control){
		ddFILT=filter.control(ddNORM,ManuelaGO,targets,annotation.package)	
			} # FILTERct 
			}

	if(!missing(wellaboveBG)){
	if(wellaboveBG){
		ddFILT=filter.wellaboveBG(ddFILT,limWellAbove,ManuelaGO,targets,annotation.package)
			} # wellaboveBG 
			}

	if(!missing(isfound)){
	if(isfound){
		ddFILT=filter.isfound(ddFILT,limISF,ManuelaGO,targets,annotation.package)
			} # isfound 
			}

	if(!missing(wellaboveNEG)){
	if(wellaboveNEG){
		ddFILT=filter.wellaboveNEG(ddFILT,ddNORM,limNEG,SDtimes=1.5,ManuelaGO,targets,annotation.package)
			} # wellaboveNEG
			}

	if(!missing(sat)){
	if(sat){
		ddFILT=filter.saturated(ddFILT,limSAT,ManuelaGO,targets,annotation.package)
			} # sat 
			}

	if(!missing(PopnOL)){
	if(PopnOL){
		ddFILT=filter.PopnOL(ddFILT,limPopnOL,ManuelaGO,targets,annotation.package)
			} # PopnOL 
			}

	if(!missing(NonUnifOL)){
	if(NonUnifOL){
		ddFILT=filter.NonUnifOL(ddFILT,limNonUnifOL,ManuelaGO,targets,annotation.package)
			} # NonUnifOL 
			}
 
	if(!missing(nas)){
	if(nas){
		ddFILT=filter.nas(ddFILT,limNAS,targets)
			} # nas
			}


	if(!missing(flag.counts)){
	if(flag.counts){
 
	flag=1  # contamos probes accross exp.conditions   
	FLAG=ddFILT$other$gIsWellAboveBG  

		
		probeFLAG=apply(FLAG,1,countFLAG,flag)
		rm(FLAG)

		cat("COUNT FLAG gIsWellAboveBG","\n")
		cat("PROBES DISTRIBUTION across exp.cond. WITH (FLAG OK) gIsWellAboveBG = ",flag,"\n")
		print(table(probeFLAG))
		cat("------------------------------------------------------","\n")

 
	flag=1  # contamos probes accross exp.conditions   
	FLAG=ddFILT$other$gIsFound  


		probeFLAG=apply(FLAG,1,countFLAG,flag)
		rm(FLAG)

		cat("COUNT FLAG gIsFound","\n")
		cat("PROBES DISTRIBUTION across exp.cond. WITH (FLAG OK) gIsFound = ",flag,"\n")
		print(table(probeFLAG))
		cat("------------------------------------------------------","\n")


	flag=0  # contamos probes accross exp.conditions   
	FLAG=ddFILT$other$gIsSaturated  


		probeFLAG=apply(FLAG,1,countFLAG,flag)
		rm(FLAG)

		cat("COUNT FLAG gIsSaturated","\n")
		cat("PROBES DISTRIBUTION across exp.cond. WITH (FLAG OK) gIsSaturated = ",flag,"\n")
		print(table(probeFLAG))
		cat("------------------------------------------------------","\n")


	flag=0  # contamos probes accross exp.conditions   
	FLAG=ddFILT$other$gIsFeatPopnOL  


		probeFLAG=apply(FLAG,1,countFLAG,flag)
		rm(FLAG)

		cat("COUNT FLAG gIsFeatPopnOL","\n")
		cat("PROBES DISTRIBUTION across exp.cond. WITH (FLAG OK) gIsFeatPopnOL = ",flag,"\n")
		print(table(probeFLAG))
		cat("------------------------------------------------------","\n")


	flag=0  # contamos probes accross exp.conditions   
	FLAG=ddFILT$other$gIsFeatNonUnifOL  


	probeFLAG=apply(FLAG,1,countFLAG,flag)
	rm(FLAG)

		cat("COUNT FLAG gIsFeatNonUnifOL","\n")
		cat("PROBES DISTRIBUTION across exp.cond. WITH (FLAG OK) gIsFeatNonUnifOL = ",flag,"\n")
		print(table(probeFLAG))
		cat("------------------------------------------------------","\n")

	}
	}


	if(!missing(makePLOT)) {
	if(makePLOT){
	

	colorfill="orange"		
	maintitle="FILTERED SIGNAL"
	
		X11()
		par(mfrow=c(1,1))
		plotDensity(ddFILT$G,maintitle)

		X11()
		par(mfrow=c(1,1))
		BoxPlot(ddFILT$G,maintitle,colorfill)

		maintitle="FILTERED DATA - RLE "
		X11()
		par(mfrow=c(1,1))
		RLE(ddFILT$G,maintitle,colorfill)
	}
	}
	return(ddFILT) 
} # end function 

