`filter.saturated` <-
function(ddFILT,limSAT,ManuelaGO,targets,annotation.package){

	minFLAGsa=0     # gIsSaturated	FLAG ok: 0 = NOT saturated (60)

	if (!is(ddFILT, "RGList")){
	  stop("'input' must be a RGList")
   	 	if (is.null(dim(ddFILT)[1])) {
        		stop("'input' is empty")
	 	}
	}
	
	if(missing(targets)){
		stop("'targets' is missing ")
	}

	if("GErep" %in% colnames(targets)){
		g1=targets$GErep  # g1 must be numeric, from 1:n
		g2=rownames(targets)
		GErep=targets$GErep 
		nGE=sum(table(table(GErep)))
	}else{
		stop("'targets' needs 'GErep' field")
	}

  
  	FLAG=ddFILT$other$gIsSaturated  
  	indexSNR=apply(FLAG,1,filterFLAG,GErep,nGE,minFLAGsa,limSAT)
	selSNR=which(unlist(indexSNR) == 1) #posiciones que pasan filtro 


# WRITING OUT THE REMOVED DATA only geneIDs and selected flags

	outfile="IsSaturated.txt"
	write.filt.out(ddFILT,selSNR,ManuelaGO,annotation.package,outfile,FLAG,targets)


	cat("FILTERING BY gIsSaturated filterFLAG","\n")
	cat("\n")
	cat("	FLAG FILTERING OPTIONS - FLAG OK = 0 - limSAT: ",limSAT,"%","\n")
	cat("	PROBES AFTER gIsSaturated FILTERING: ",sum(indexSNR),"\n")
	cat("	IsSaturated OUT :",length(ddFILT$genes$ProbeName[-selSNR]),"\n")
	cat("------------------------------------------------------","\n")

# EXTRACTING THE SELECTED PROBES  
	
 ddFILT=ddFILT[selSNR,]
 return(ddFILT) 

} #end function 

