`filter.wellaboveBG` <-
function(ddFILT,limWellAbove,ManuelaGO,targets,annotation.package){

	
	minFLAGwa=1 	# gIsWellAboveBG:FLAG ok: 1 = feature IS Well Above BG (62,85)


	if (!is(ddFILT, "RGList")){
	  stop("'input' must be a RGList")
   	 	if (is.null(dim(ddFILT)[1])) {
        		stop("'input' is empty")
	 	}
	}
	
	if(missing(targets)){
		stop("'targets' is missing ")
	}

	if("GErep" %in% colnames(targets)){
		g1=targets$GErep  # g1 must be numeric, from 1:n
		g2=rownames(targets)
		GErep=targets$GErep 
		nGE=sum(table(table(GErep)))
	}else{
		stop("'targets' needs 'GErep' field")
	}


	FLAG=ddFILT$other$gIsWellAboveBG 
 	indexSNR=apply(FLAG,1,filterFLAG,GErep,nGE,minFLAGwa,limWellAbove)
 	selSNR=which(unlist(indexSNR) == 1) # posiciones que pasan filtro 


# WRITING OUT THE REMOVED DATA only geneIDs and selected flags


	outfile="IsNOTWellAboveBG.txt"
	write.filt.out(ddFILT,selSNR,ManuelaGO,annotation.package,outfile,FLAG,targets)

	cat("FILTERING BY IsWellAboveBG filterFLAG","\n")
	cat("\n")
	cat("	FLAG FILTERING OPTIONS - FLAG OK = 1 - limWellAbove: ",limWellAbove,"%","\n")
	cat("	PROBES BEFORE FILTERING: ",dim(ddFILT)[1],"\n")
	cat("	PROBES AFTER QC FILTERING: ",sum(indexSNR),"\n")
	cat("	IsNOTWellAboveBG OUT :",length(ddFILT$genes$ProbeName[-selSNR]),"\n")
	cat("------------------------------------------------------","\n")

# EXTRACTING THE SELECTED PROBES  
	
 ddFILT=ddFILT[selSNR,]
 return(ddFILT)
} # end function 

