`filter.wellaboveNEG` <-
function(ddFILT,ddNORM,limNEG,SDtimes,ManuelaGO,targets,annotation.package){

	 
	if (!is(ddFILT, "RGList")){
	  stop("'input ddFILT' must be a RGList")
   	 	if (is.null(dim(ddFILT)[1])) {
        		stop("'input' is empty")
	 	}
	}

	if (!is(ddNORM, "RGList")){
	  stop("'input ddNORM' must be a RGList in log2 scale")
   	 	if (is.null(dim(ddNORM)[1])) {
        		stop("'input' is empty")
	 	}
	}

	if(missing(targets)){
		stop("'targets' is missing ")
	}

	if("GErep" %in% colnames(targets)){
		g1=targets$GErep  # g1 must be numeric, from 1:n
		g2=rownames(targets)
		GErep=targets$GErep 
		nGE=sum(table(table(GErep)))
	}else{
		stop("'targets' needs 'GErep' field")
	}

	indexneg=which(ddNORM$genes$ControlType == -1)
	NEG=ddNORM$G[indexneg,]  # ddNORM$G: MeanSignal in log2 scale
	MeanNeg=apply(NEG,2,mean)
	SdNeg=apply(NEG,2,sd)
	Limit=MeanNeg + SDtimes*(SdNeg)
  
  	
  	FLAG=ddFILT$G 
  	indexSNR=apply(FLAG,1,filterWellAboveSIGNALv2,GErep,nGE,Limit,limNEG)
  	selSNR=which(unlist(indexSNR) == 1) #posiciones que pasan filtro 

		
# WRITING OUT THE WellAboveNeg.out filtered DATA 


	outfile="IsNOTWellAboveNEG.txt"
	VALUES=round(ddFILT$G,3)
	write.filt.out(ddFILT,selSNR,ManuelaGO,annotation.package,outfile,VALUES,targets)


		cat("FILTERING BY WellAboveNeg filterWellAboveSIGNALv2 ~ FLAG","\n")
		cat("\n")
		cat("	FLAG FILTERING OPTIONS - limNEG: ",limNEG,"%","\n")
  		cat("	Limit computed as MeanNeg + ",SDtimes," x (SDNeg) ","\n")
  		
  		cat("	Limit: ",round(Limit,2),"\n")
  		cat("\n")
		cat("PROBES AFTER WellAboveNeg FILTERING: ",sum(indexSNR),"\n")
		cat("WellAboveNeg OUT :",length(ddFILT$genes$ProbeName[-selSNR]),"\n")
		cat("------------------------------------------------------","\n")


# EXTRACTING THE SELECTED PROBES  
	
	ddFILT=ddFILT[selSNR,]
	return(ddFILT)

} # end function 

