`genes.rpt.agi` <-
function(dd,annotation.package,raw.data,WRITE.html,REPORT) {

#require(hgug4112a.db)
#require(mgug4122a.db)

	if (!is(dd, "RGList")){
	  stop("'input' must be a RGList")
   	 	if (is.null(dim(dd)[1])) {
        		stop("'input' is empty")
	 	}
	}

        if(missing(annotation.package)) {
                stop("A known'annotation.package' is needed ")
        }else{
                if(annotation.package =="notAnnPack"){
                        stop("A known'annotation.package' is needed ")
                }
        }

	if(missing(raw.data)){
		stop("'raw.data' is missing")
	}else{
		if(raw.data){
			input="RAW"
			FILTERct=TRUE
			selSNR=which(dd$genes$ControlType==0)
 			ddDUP=dd[selSNR,]
			ddDUP$G=log2(ddDUP$G)
 			nGEN=dim(ddDUP)[1]
			cat("\n")
			cat("GENE SETS: same genes interrogated by different probes","\n")
 			cat("		FILTERING BY ControlType FLAG","\n")
			cat("		RAW DATA: PROBES AFTER ControlType FILTERING: ",nGEN,"\n")
			cat("\n")

		}else{
			input="PROCCESSED DATA "
			ddDUP=dd
			nGEN=dim(ddDUP)[1]
			cat("GENE SETS: same genes interrogated by different probes","\n")
 			cat("	PROCESSED DATA: PROBES ",nGEN,"\n")
			cat("\n")			
		}
	}

	cat("	INPUT DATA:",input,"\n")
	cat("	CHIP:",annotation.package,"\n")
	cat("\n")

# IDENTIFICAMOS GEN-SETS: group of different probes that 
#		interrogate the same accnum-gene is called a GEN SET
	
    	PROBE_ID=ddDUP$genes$ProbeName
	GENE_ID = unlist(lookUp(PROBE_ID, annotation.package, "ACCNUM") )
	probe.chr=ddDUP$other$chr_coord[,1]
	A=apply(ddDUP$G,1,mean)

# ELIMINAMOS NON-CONTROLS  replicated x 10 PROBES. 

	dup=which(duplicated(PROBE_ID) ==TRUE)
	reps=table(PROBE_ID[dup])
	rN=names(reps)	
	cat("	PROBE SETS (NON-CTRL prob rep. x 10):	",length(rN),"\n")
	
	PROBE_ID=PROBE_ID[-dup]
	probe.chr=probe.chr[-dup]
	A=A[-dup]
	GENE_ID=GENE_ID[-dup]	

# IDENTIFICAMOS GEN SETS (GENES REPLICATED) 

    	order.genID=order(GENE_ID)
   	PROBE_ID=PROBE_ID[order.genID]
	GENE_ID=GENE_ID[order.genID]
	probe.chr=probe.chr[order.genID]
      	A=A[order.genID]

	gene.DUP=which(duplicated(GENE_ID)==TRUE) # Saco Dups 
	gene.NA=which(is.na(GENE_ID))
	index=setdiff(gene.DUP,gene.NA) 		# me quedo con los que dups (excepto NAs)
	
	GENE_ID.dup=unique(GENE_ID[index])		# nombre de genes DUPS (unicos, al hacer dups, pilla 
							# todos los rep, y si hay 3, pilla 2 y deja uno   
	index=which(GENE_ID %in% GENE_ID.dup)
	

	PROBE_ID=PROBE_ID[index]
	probe.chr=probe.chr[index]
	A=A[index]
	GENE_ID=GENE_ID[index]
	gene.sym=lookUp(PROBE_ID,annotation.package,"SYMBOL") # symbol 
		
	cat("	GEN-SETS (REPLICATED GENES):		",length(GENE_ID.dup),"\n")
	cat("	PROBES in gen-sets:			",length(PROBE_ID),"\n")
	

	if(WRITE.html){
  		filename=paste("Gen.Sets",annotation.package,input,"html",sep=".")
  		title="Replicated Gene - Agi4x44PreProcess package -"
  		head <- c("PROBE ID","ACCNUM","SYMBOL","probe chr coord")

   			ensembl.htmlpage(PROBE_ID,probe.chr,filename,annotation.package,
				title, table.head=head,table.center = TRUE,
				other=list(unlist(GENE_ID),unlist(gene.sym),unlist(probe.chr)))
		} # WRITE.html	

if(REPORT){
# **************************************************
# calculo distancia maxima entre probes replicados 
# saco cromosoma (Agilent da genes iguales en chr distintos !!!) 

#	PB.dist=rep.int(0,length(GENE_ID.dup))
#  	CHR.num=rep.int(0,length(GENE_ID.dup))
	PB.dist=seq(0, 0,length=length(GENE_ID.dup))
	CHR.num=seq(0, 0,length=length(GENE_ID.dup))

  	for(ii in 1:length(GENE_ID.dup)){	
    		index=which(GENE_ID %in% GENE_ID.dup[ii])
      		chr.coord=probe.chr[index]
			if(anyNA(chr.coord)){	
        			start=as.numeric(unlist(sapply(chr.coord,subCHR))[2,])  # ver subCHR in AGI.PLRFunctions.R.
	  			chr=unlist(sapply(chr.coord,subCHR))[1,]
					if(anyNA(start)){  
		     	  			PB.dist[ii]=max(dist(start))
					}else{
						PB.dist[ii]=-1
					}
			}
			if(anyNA(chr)){
	        		if(length(unique(chr)) > 1){ 
		    			CHR.num[ii]=1
        				}
				}else{
				CHR.num[ii]=-1
			}
   	} # ii


# **************************************************
# quito probes con dist NA (no disponen de coordenada) 
# para el resto, saco output con:
#  PROBE","# probes","ACCNUM","SYMBOL","MAX d chr coord","chr coord"

iNA=which(PB.dist > 0)  # NAS recodificados como "-1" 
PB.mod=PB.dist[iNA]

cat("-------------------------------------------------------------","\n")
cat("CHR. DISTANCES - between genes within the same 'GEN SET'","\n")
print(summary(PB.mod))
cat("\n")

 cat("-------------------------------------------------------------","\n")
 cat("# of 'GEN SETS' that have replicated members at a chr coord Dist: ","\n")
 cat("	 > 50000:	",length(which(PB.mod >= 50000)),"\n")
 cat("	 > 100000:	",length(which(PB.mod >= 100000)),"\n")
 cat("	 > 200000:	",length(which(PB.mod >= 200000)),"\n")
 cat("	 > 500000:	",length(which(PB.mod >= 500000)),"\n")
 cat("	 > 1000000:	",length(which(PB.mod >= 1000000)),"\n")
 cat("-------------------------------------------------------------","\n")

# **************************************************
maxLength=0		# max dist between probes (chr coord) to be writen in result file 

iMAX=which(PB.mod >= maxLength)

	# iMAX es menor que length(GENE_ID.dup), porque aqui estamos
	# calculando distancias cromosomicas (PB.dist), y algunas no
	# se pueden calcular: ver arriba => 'PB.dist[ii]=-1' 

cat("'GEN SETS' with members separated >","'", maxLength,"bases","'",length(iMAX),"\n")
	  
	#  index0=rep.int(0,length(iMAX))
	#  pi=rep.int(0,length(iMAX))
	#  Li=rep.int(0,length(iMAX))
	#  gi=rep.int(0,length(iMAX))
	#  gs=rep.int(0,length(iMAX))
	#  pd=rep.int(0,length(iMAX))
	#  cc=rep.int(0,length(iMAX))
	
	index0=seq(0,0,length=length(iMAX))
	pi=seq(0,0,length=length(iMAX))
	Li=seq(0,0,length=length(iMAX))
	gi=seq(0,0,length=length(iMAX))
	gs=seq(0,0,length=length(iMAX))
	pd=seq(0,0,length=length(iMAX))
	cc=seq(0,0,length=length(iMAX))
  
  for(ii in 1:length(iMAX)){
	index0[ii]=which(GENE_ID %in% GENE_ID.dup[iMAX[ii]])[1]
      	paux=as.character(PROBE_ID[which(GENE_ID %in% GENE_ID.dup[iMAX[ii]])])
      	caux=as.character(probe.chr[which(GENE_ID %in% GENE_ID.dup[iMAX[ii]])])
       
      	pi[ii]=paste.character(paux)	# see function paste.character in AGI.PLRFunctions.R
	cc[ii]=paste.character(caux)  # see function paste.character in AGI.PLRFunctions.R

	Li[ii]=length(paux)
   	gi[ii]=unlist(GENE_ID[index0[ii]][1])
      	gs[ii]=unlist(gene.sym[index0[ii]][1])
      
	pd[ii]=PB.mod[iMAX[ii]]
  }

  	outfile=paste("Gen.Sets.CHR.dist",annotation.package,
		input,maxLength,"txt",sep=".")

  	result=data.frame(pi,Li,gi,gs,pd,cc)

 	colnames(result)=c("PROBE","# probes","ACCNUM","SYMBOL",
		"MAX d chr coord","chr coord")

  	write.table(result,file=,outfile,row.names=F,col.names = TRUE,
		quote=F,dec=".",eol = "\n",sep = "\t")



 		cat("DISTRIBUTION of 'GENE SET' size","\n")
	 	for (ii in 2:length(unique(Li))){
 			cat("	size:",ii," - ",length(which(Li ==ii)),"\n")
	 	}

# **************************************************
# probes en distintos cromosomas 


iDIF=which(CHR.num ==1)
cat("-------------------------------------------------------------","\n")
cat("'GEN SET' members reported in 'different' CHR:",length(iDIF),"\n")
cat("\n")

  #	index0=rep.int(0,length(iDIF))
	index0=seq(0,0,length=length(iDIF))
  		for(ii in 1:length(iDIF)){
			index0[ii]=which(GENE_ID %in% GENE_ID.dup[iDIF[ii]])[1]

			cat(PROBE_ID[which(GENE_ID %in% GENE_ID.dup[iDIF[ii]])],"\n")
			cat(" ",unlist(GENE_ID[index0[ii]])," - ",unlist(gene.sym[index0[ii]]),"\n")

        		chr.coord= probe.chr[which(GENE_ID %in% GENE_ID.dup[iDIF[ii]])]
        		chr=unlist(sapply(chr.coord,subCHR))[1,] 
        		cat("  CHR num:",chr,"\n")
  	}
cat("-------------------------------------------------------------","\n")

} # REPORT 


} # end function 

