`gsea.files` <-
function(eset,targets,annotation.package){

#require(hgug4112a.db)
#require(mgug4122a.db)
	 
	cat("GSEA OUTPUT FILES ","\n")
	cat("\n")

	if (!is(eset, "ExpressionSet")){
	  stop("'object' must be a ExpressionSet")
   	 	if (is.null(nrow(exprs(eset)))) {
        		stop("'object' is empty")
	 	}
	}

	if(missing(targets)){
		stop("'targets' is missing ")
	}

	if("GErep" %in% colnames(targets)){
		g1=targets$GErep  # g1 must be numeric, from 1:n
		g2=rownames(targets)
		GErep=targets$GErep 
		nGE=sum(table(table(GErep)))
	}else{
		stop("'targets' needs 'GErep' field")
	}

	
        if(missing(annotation.package)) {
                stop("A known'annotation.package' is needed ")
        }else{
                if(annotation.package =="notAnnPack"){
                        stop("A known'annotation.package' is needed ")
                }
        }

	cat("	DataSet.gct and Phenotypes.cls ","\n")


# UNIQUE SYMBOLS 

	PROBE_ID=featureNames(eset)
	gene.sym=lookUp(PROBE_ID,annotation.package,"SYMBOL") 
	gene.name=lookUp(PROBE_ID,annotation.package,"GENENAME") 
	index=which(duplicated(gene.sym)==FALSE)  

	gene.sym=unlist(gene.sym[index])
	gene.name=unlist(gene.name[index])

	EXPvalues=round(exprs(eset)[index,],3)


k=0
for(i in 1:(nGE-1)){
 for(j in (i+1):nGE){
 	k=k+1

# -------------- DATASET.gct ------------------------

	contrast=paste(levels(targets$Treatment)[i],levels(targets$Treatment)[j],sep="-")

	
		outfileds=paste(contrast,"GSEAds","gct",sep=".")
		outfileph=paste(contrast,"GSEAph","cls",sep=".")

	pos1=which(GErep == i)   
	pos2=which(GErep == j)  
	values=EXPvalues[,c(pos1,pos2)] 
	gg2=g2[c(pos1,pos2)]
	gg1=g1[c(pos1,pos2)]

	genesGSEA=dim(values)[1]
	samplesGSEA=dim(values)[2]


		cat("  ",k,contrast, "\n")
		cat("       unique gene symbols: ",genesGSEA,"\n")
		cat("       samples:             ",samplesGSEA,"\n")
		cat("\n")


	aux=rep("",samplesGSEA+1)
	row1=c("#1.2",aux)
	aux=rep("",samplesGSEA)
	row2=c(genesGSEA,samplesGSEA,aux)
	result=cbind(as.character(gene.sym),as.character(gene.name),values)
	colnames=c("NAME","DESCRIPTION",paste(gg2,gg1,sep="/"))
	DataSet=rbind(row1,row2,colnames,result)
	write.table(DataSet,file=outfileds,row.names=F,col.names = FALSE,quote=F,dec=".",eol = "\n",sep = "\t")

# -------------- PHENOTYPE.cls ------------------------

	aux=rep("",samplesGSEA-3)
	row1=c(samplesGSEA,2,"1",aux)
	aux=rep("",samplesGSEA-3)

	row2=c("#",as.character(targets$Treatment[pos1[1]]),as.character(targets$Treatment[pos2[1]]),aux)
	row3=as.character(targets$Treatment[c(pos1,pos2)]) 
	Phenotypes=rbind(row1,row2,row3)

	write.table(Phenotypes,file=outfileph,row.names=F,
		col.names = FALSE,quote=F,dec=".",eol = "\n",sep = "\t")
 } # j
} # i

rm(values)
rm(EXPvalues)


} # end function 

