`read.AgilentFE` <-
function(targets,makePLOT){


	if (!is(targets, "data.frame")){
        stop("'targets' must be a data.frame")
	}

	ddaux=read.maimages(files=targets$FileName,source="agilent",
		other.columns=list(IsFound="gIsFound",
			IsWellAboveBG="gIsWellAboveBG",
			IsSaturated="gIsSaturated",
			IsFeatNonUnifOF="gIsFeatNonUnifOL",
			IsFeatPopnOL="gIsFeatPopnOL",
			ChrCoord="chr_coord"),
		columns=list(Rf="gProcessedSignal",
			Gf="gMeanSignal",
			Rb="gBGMedianSignal",
			Gb="gBGUsed"),
		verbose=T,sep="\t",quote="")	
	

		if(length(ddaux$genes$Sequence)==0){
			cat(" INPUT DATA DOES NOT CONTAIN - Sequence and chr_coord","\n")
			cat(" SCANN THE DATA USING AFE 9.5.3.1","\n")
			stop(" the script will stop now")
		}

	dd=new("RGList")

		dd$R=ddaux$R
		dd$G=ddaux$G
		dd$Rb=ddaux$Rb
		dd$Gb=ddaux$Gb

		dd$targets=ddaux$targets
		dd$genes=ddaux$genes[,c(4,6,7,8,9,10)]
		dd$other=ddaux$other 

  	rm(ddaux)
              
		cat("","\n")
		cat("  RGList:","\n")
		cat("	dd$R:	'gProcessedSignal' ","\n")
		cat("	dd$G:	'gMeanSignal' ","\n")
		cat("	dd$Rb:	'gBGMedianSignal' ","\n")
		cat("	dd$Gb:	'gBGUsed' ","\n")
		cat("","\n")
	
	
	if(!missing(makePLOT)) {
	  if(makePLOT){
		
		MMM=log2(dd$R)
		maintitle="ProcessedSignal"
		colorfill="red"
			X11()
			par(mfrow=c(1,1))
			BoxPlot(MMM,maintitle,colorfill)
			X11()
			par(mfrow=c(1,1))
			plotDensity(MMM,maintitle)

		MMM=log2(dd$G)
		maintitle="MeanSignal"
		colorfill="green"
			X11()
			par(mfrow=c(1,1))
			BoxPlot(MMM,maintitle,colorfill)
			X11()
			par(mfrow=c(1,1))
			plotDensity(MMM,maintitle)

		MMM=log2(dd$Gb)
		maintitle="BGUsed"
		colorfill="orange"
			X11()
			par(mfrow=c(1,1))
			BoxPlot(MMM,maintitle,colorfill)

		MMM=log2(dd$Rb)
		maintitle="BGMedianSignal"
		colorfill="blue"
			X11()
			par(mfrow=c(1,1))
			BoxPlot(MMM,maintitle,colorfill)

	  } # MAKEPLOT
	}

return(dd)

} # end function 

