`summarize.probe` <-
function(ddFILT,makePLOT,targets) {

	cat("SUMMARIZATION OF non-CTRL PROBES ","\n")
	cat("\n")
	if (!is(ddFILT, "RGList")){
	  stop("'input' must be a RGList")
   	 	if (is.null(dim(ddFILT)[1])) {
        		stop("'input' is empty")
	 	}
	}

	if(missing(targets)){
		stop("'targets' is missing ")
	}

	if("GErep" %in% colnames(targets)){
		GErep=targets$GErep 
		nGE=sum(table(table(GErep)))
	}else{
		stop("'targets' needs 'GErep' field")
	}
		
	ddDUP=ddFILT 
	dup=which(duplicated(ddDUP$genes$ProbeName)==TRUE)

		if(length(dup) == 0){
			ddPROC=ddFILT
			stop("NOT DUPLICATED ProbeName in chip")
			} 

	
	Ldup=length(dup)   
	reps=table(ddDUP$genes$ProbeName[dup])
	t=table(reps)
	rN=names(reps)
	Lreps=length(rN)
	
	nARR=dim(ddDUP)[2]
	MEDmat=matrix(ncol=nARR,nrow=Lreps)
	colnames(MEDmat)=rownames(targets)
	rownames(MEDmat)=rN

	if(Lreps !=0){
 		for(i in 1:Lreps){
  			index=which(ddDUP$genes$ProbeName==rN[i])
  			MED=apply(ddDUP$G[index,],2,median)
  			MEDmat[i,]=MED
 		}
		ddPROC=ddDUP[-dup,]
	} else{
		ddPROC=ddDUP
	}

		# cat("REPLICATED NonCtrl",Lreps,"\n")
		# cat("DISTRIBUTION OF REPLICATED NonControl Probes","\n")
		# print(t)
		# cat("# REPLICATED (redundant) probeNames",Ldup,"\n")
		# cat("\n")
		cat("SUMMARIZED DATA: ",dim(ddPROC),"\n")
		cat("------------------------------------------------------","\n")

	
	if(!missing(makePLOT)) {
	if(makePLOT){
	
	colorfill="green"		
	maintitle="NORMALIZED & SUMMARIZED SIGNAL"

	X11()
	par(mfrow=c(1,1))
	plotDensity(ddPROC$G,maintitle)

	X11()
	par(mfrow=c(1,1))
	BoxPlot(ddPROC$G,maintitle,colorfill)

	X11()
	maintitle="NORMALIZED & SUMMARIZED DATA - RLE "
	RLE(ddPROC$G,maintitle,colorfill)

	X11()
	par(mfrow=c(2,2),ask=T)
	maintitle="summ data"
	MVAplotMED(ddPROC$G,colorfill,maintitle)

	X11()
	par(mfrow=c(1,1))
	hierclus(ddPROC$G,GErep,methdis="euclidean",
        methclu="complete",sel=FALSE,100)

	}
	}
 
return(ddPROC) 
} # end function 

