`write.control.out` <-
function(ddFILT,selSNR,annotation.package,ManuelaGO,targets){ 

#require(hgug4112a.db)
#require(mgug4122a.db)

	if (!is(ddFILT, "RGList")){
	  stop("'input' must be a RGList")
   	 	if (is.null(dim(ddFILT)[1])) {
        		stop("'input' is empty")
	 	}
	}
	
	if(missing(targets)){
		stop("'targets' is missing ")
	}

	if("GErep" %in% colnames(targets)){
		g1=targets$GErep  # g1 must be numeric, from 1:n
		g2=rownames(targets)
	}else{
		stop("'targets' needs 'GErep' field")
	}
	PROBE_ID=ddFILT$genes$ProbeName
	values=round(ddFILT$G,3)
	flagsGID=matrix(paste(ddFILT$other$gIsWellAboveBG,ddFILT$other$gIsFound,sep=" - "),
		nrow=dim(ddFILT)[1],ncol=dim(ddFILT)[2])

if(ManuelaGO == TRUE && length(PROBE_ID > 0)) {

	GENE_ID= lookUp(PROBE_ID,annotation.package, "ACCNUM") 
	gene.sym=lookUp(PROBE_ID,annotation.package,"SYMBOL") 
	gene.num=lookUp(PROBE_ID,annotation.package,"ENTREZID")  
	gene.des=lookUp(PROBE_ID,annotation.package,"GENENAME") 
	probe.seq=ddFILT$genes$Sequence
	probe.chr=ddFILT$other$chr_coord[,1]

		result=data.frame(PROBE_ID,as.character(probe.chr),
			as.character(probe.seq),as.character(GENE_ID),
			as.character(gene.sym),as.character(gene.num),
			as.character(gene.des),values)

		colnames(result)=c("PROBE","Probe Chr-Coord","Probe Sequence",
		"ACCNUM","SYMBOL","ENTREZID","DESCRIPTION",paste(g2,g1,sep=" - "))

		outfile="RawDataNOCtrl.txt"
		write.table(result,file=outfile,row.names=F,
			col.names = TRUE,quote=F,dec=".",eol = "\n",sep = "\t")

		result=data.frame(PROBE_ID,flagsGID)
		colnames(result)=c("PROBE & WABackG/IsFound - (1 is Found)",paste(g2,g1,sep=" - "))

		outfile="RawDataNOCtrlWABKGandISF.txt"
		write.table(result,file=outfile,row.names=F,
			col.names = TRUE,quote=F,dec=".",eol = "\n",sep = "\t")

		rm(values)

}


if(ManuelaGO == FALSE & length(PROBE_ID > 0)) {

	GENE_ID=ddFILT$genes$SystematicName
	gene.sym=ddFILT$genes$GeneName
	gene.des=ddFILT$genes$Description
	probe.seq=ddFILT$genes$Sequence
	probe.chr=ddFILT$other$chr_coord[,1]

		result=data.frame(PROBE_ID,as.character(probe.chr),
			as.character(probe.seq),as.character(GENE_ID),
			as.character(gene.sym),as.character(gene.des),values)

		colnames(result)=c("PROBE","Probe Chr-Coord","Probe Sequence",
			"ACCNUM","SYMBOL","DESCRIPTION",paste(g2,g1,sep=" - "))

		outfile="RawDataNOCtrl.txt"
		write.table(result,file=outfile,row.names=F,
			col.names = TRUE,quote=F,dec=".",eol = "\n",sep = "\t")
		
		result=data.frame(PROBE_ID,flagsGID)
		colnames(result)=c("PROBE & WABackG/IsFound - (1 is Found)",paste(g2,g1,sep=" - "))

		outfile="RawDataNOCtrlWABKGandISF.txt"
		write.table(result,file=outfile,row.names=F,
			col.names = TRUE,quote=F,dec=".",eol = "\n",sep = "\t")

		rm(values)
} 
} # end function 

