`write.eset` <-
function(eset,ddPROC,annotation.package,targets) {

#require(hgug4112a.db)
#require(mgug4122a.db)

	if (!is(eset, "ExpressionSet")){
	  stop("'object' must be a ExpressionSet")
   	 	if (is.null(nrow(exprs(eset)))) {
        		stop("'object' is empty")
	 	}
	}

	if(missing(targets)){
		stop("'targets' is missing ")
	}

	if("GErep" %in% colnames(targets)){
		GErep=targets$GErep 
		nGE=sum(table(table(GErep)))
		g1=targets$GErep  # g1 must be numeric, from 1:n
		g2=rownames(targets)
	}else{
		stop("'targets' needs 'GErep' field")
	}
	
	if(missing(annotation.package)) {
                stop("'annotation.package' is needed ")
        }else{
                if(annotation.package =="notAnnPack"){
                	cat("NOT ANNOTATION PACKAGE AVAILABLE AT THIS MOMENT","\n")
                        ManuelaGO=FALSE
                }else{
                        if (annotation.package %in% .packages(all = TRUE)) {
                        } else {
                       		cat("   R will proceed to install the annotation package:",annotation.package,"\n")
                        	install.packages(annotation.package)
                        }
                ManuelaGO=TRUE
                }
        }


	PROBE_ID=featureNames(eset)
	values=round(exprs(eset),3)
	# cat("PROCESSED DATA  :",length(PROBE_ID),"\n")
	# cat("\n")

	if(ManuelaGO == TRUE & length(PROBE_ID > 0)) {

	GENE_ID= lookUp(PROBE_ID, annotation.package, "ACCNUM") # from annotate 
	gene.sym=lookUp(PROBE_ID,annotation.package,"SYMBOL") # symbol 
	gene.num=lookUp(PROBE_ID,annotation.package,"ENTREZID") # Entrez ID 
	gene.des=lookUp(PROBE_ID,annotation.package,"GENENAME") 

		result=data.frame(PROBE_ID,as.character(GENE_ID),
			as.character(gene.sym),as.character(gene.num),
			as.character(gene.des),values)

		colnames(result)=c("PROBE","ACCNUM","SYMBOL","ENTREZID",
			"DESCRIPTION",paste(g2,g1,sep="/"))

	}
	
	if(ManuelaGO == FALSE & length(PROBE_ID > 0)) {

	GENE_ID=ddPROC$genes$Systematic
	gene.sym=ddPROC$genes$GeneName
	gene.des=ddPROC$genes$Description

		result=data.frame(PROBE_ID,as.character(GENE_ID),
			as.character(gene.sym),as.character(gene.des),values)

		colnames(result)=c("PROBE","ACCNUM","SYMBOL",
			"DESCRIPTION",paste(g2,g1,sep="/"))

	} 
	outfile="ProcessedData.txt"
	write.table(result,file=outfile,row.names=F,col.names = TRUE,
		quote=F,dec=".",eol = "\n",sep = "\t")
	
} # END.FUNCTION 

