\name{CV.rep.probes}
\alias{CV.rep.probes}
\title{  Non-control replicated Probes identication}
\description{
	Computes the %CV for each array from the set of 
	non-control replicated probes 
}
\usage{
CV.rep.probes(ddDUP, annotation.package, foreground, raw.data, writeR,targets)
}
\arguments{
  \item{ddDUP}{An RGList  }
  \item{annotation.package}{a character specifying the AGI annotation package: 'hgug4112a.db','mgug4122a.db' }
  \item{foreground}{a character specifying the signal from wich the CV is calculated: 'MeanSignal' or 
			'ProcessedSignal' }
  \item{raw.data}{logical, \code{TRUE} if the RGList contains the RAW data }
  \item{writeR}{logical, \code{TRUE} to write the REPORT FILE 'Probe.Sets.txt' }
  \item{targets}{data.frame containing the TARGET file }
}
\details{
	Agilent arrays contain a number of non-control probes replicated up to 	
	ten times spread accross the array. This allows computing the %CV (percent
	of coefficient of variation) for each array. The CV is computed for
	every set of replicated probes. CV median is reported as the array CV.
	A lower CV median indicates a better array reproducibility.
}
\value{
 	A txt file 'Probe.Sets.txt' that contains PROBE, number of replicates, ACCNUM code, 
	SYMBOL code, DESCRIPTION of the gene, and probe % CV on each 
	of the arrays 
	A boxplot that shows CV distribution computed for every
	set of replicated probes
}
\author{ Pedro Lopez-Romero }
\examples{
\dontrun{
	data(dd)
	data(targets)
	library(hgug4112a.db)
	CV.rep.probes(dd,"hgug4112a.db",
                foreground="MeanSignal",raw.data=TRUE,writeR=TRUE,targets)
}
}
\keyword{documentation}
\keyword{utilities}
