\name{build.eset}
\alias{build.eset}
\title{ ExpressionSet object from a RGList}
\description{
	It creates an 'ExpressionSet' object from a 'RGList' containing
	unique ProbeNames  
}
\usage{
build.eset(RGlist, targets, makePLOT, annotation.package)
}
\arguments{
  \item{RGlist}{An RGList containing normally the processed data}
  \item{targets}{data.frame with the targets structure }
  \item{makePLOT}{logical, if \code{TRUE} it makes a 'heatmap' with the 100 greater variance
		genes, a 'hierarchical cluster' with all the genes and a  pca plot}
  \item{annotation.package}{a character specifying the AGI annotation package: 'hgug4112a.db','mgug4122a.db' }
}
\details{
	It creates an ExpressionSet object from a RGList. 
        Usually this function is applied to an RGList object containing
        the processed data. 
}
\value{
	An ExpressionSet object
}
\author{ Pedro Lopez-Romero }
\seealso{\code{\link{write.eset}}  }
\examples{
\dontrun{
	data(dd)
	data(targets)
	library(hgug4112a.db)
	selSNR=which(dd$genes$ControlType==0)
        dd.aux=dd[selSNR,]
	index=which(duplicated(dd.aux$genes$ProbeName)==FALSE)
	dd.aux=dd.aux[index,]
	eset.test=build.eset(dd.aux,targets,makePLOT=TRUE,
                annotation.package="hgug4112a.db")

}
}
\keyword{documentation}
\keyword{utilities}
