\name{dd}
\alias{dd}
\docType{data}
\title{ data example (RGList) }
\description{
	Data, extracted from scanned images using Agilent Feature Extraction Software, are stored
	in a RGList object. 
	This example includes 2 experimental conditions. Two replicates are considered
}
\usage{data(dd)}
\details{
	A data example is provided, in which the original data have been trimmed 
	to reduced the disk space storing. As a consequence, some of the functions
	regarding countint replicated probes, etc., will produce numbers that
	will not coincide with a 'real data'. Despite of this, the example is valid 
	to illustrate all the function features of the functions included in the package.

	Chips were scanned using the Agilent G2567AA
        Microarray Scanner System (Agilent Technologies)
        with the extended dynamic range option turned on.
        Image analysis and data collection were carried out
        using the Agilent Feature Extraction 9.1.3.1. (AFE).
        For the background signal calculation the AFE was set to use the spatial detrend surface
        value that estimate the noise due to a systematic gradient on the array and
        whose computation is based on a Loess algorithm. Details of how the spatial
        detrend algorithm works can be found in the AFE reference guide.

	Data, colected with the Agilent Feature Extraction Software, are stored
	in a RGList object with the following components: 
	 	- dd\$R:    			'gProcessedSignal'
                - dd\$G:   			'gMeanSignal'
                - dd\$Rb:  			'gBGMedianSignal' 
                - dd\$Gb:  			'gBGUsed' 
		- dd\$targets 			'targets'
		- dd\$genes\$ProbeName		'Probe Name'
                - dd\$genes\$GeneName		'Gene Name'
                - dd\$genes\$SystematicName	'Systematic Name'
                - dd\$genes\$Description	'Description Name '
                - dd\$genes\$Sequence		'60 bases Sequence'
                - dd\$genes\$ControlType	'FLAG to specify the sort of feature'
		- dd\$other\$gIsWellAboveBG	'FLAG IsWellAboveBG'
                - dd\$other\$gIsFound		'FLAG IsFound'
                - dd\$other\$gIsSaturated	'FLAG IsSaturated'
                - dd\$other\$gIsFeatPopnOL	'FLAG IsFeatPopnOL'
                - dd\$other\$gIsFeatNonUnifOL	'FLAG IsFeatNonUnifOL'
                - dd\$other\$chr\_coord		'CHR coordinate (obtained from Agilent data files)
	Later, the if an annotation package exists, the fields 'SystematicName', 'GeneName' 
	and 'Description' are replaced, respectively,  by the corresponding ACCNUM, SYMBOL 
	and DESCRIPTION obtained from the annotation package.
}
\seealso{
	code{\link{read.targets}}
        code{\link{targets}}
}
\examples{
\dontrun{
	data(dd)
	head(data)
}
}
\keyword{datasets}
