\name{filter.NonUnifOL}
\alias{filter.NonUnifOL}
\title{  probes.filter (Internal function) }
\description{
        An internal function to be used by \code{\link{filter.probes}}
}

\usage{
filter.NonUnifOL(ddFILT, limNonUnifOL, ManuelaGO, targets, annotation.package)
}
\arguments{
  \item{ddFILT}{ an RGlist object }
  \item{limNonUnifOL}{ for a given feature xi accros samples, is the
                maximum % of spots that can be seen
                in a experimental condition with a saturation-FLAG = 1 (Is Non Uni OL)  }
  \item{ManuelaGO}{ logical, if a known annotation package is available then
        it is \code{TRUE} }
  \item{targets}{  data.frame with the target structure }
  \item{annotation.package}{  a character specifying the AGI annotation package: 'hgug4112a.db','mgug4122a.db' }
}
\details{
	To keep good quality probes, we filtered out probes that has more than y% of the replicates
        in at least one experimental condition with a flag indicating the
        presence of non-uniformity outlier.
	A feature is non-uniform outlier if its pixel noise exceeds a threshold established for a uniform feature. 1 indicates Feature
        is a non-uniformity outlier.
}
\value{
	An RGlist with probes that are not non-uniformity Outlier
        (according to the correspondind AFE flag and the filtering options).
        It also writes an output file (IsFeatNonUnifOL.txt) that
        contains probes that were filtered out because
        they were considered non-uniformity Outlier.
}
\author{ Pedro Lopez-Romero }
\seealso{ \code{\link{filter.probes}} }
\examples{
\dontrun{
        data(dd)
        data(targets)
	library(hgug4112a.db)
        ddFILT=filter.NonUnifOL(dd,25,TRUE,targets,"hgug4112a.db")
        dim(ddFILT)
}
}
\keyword{documentation}
\keyword{utilities}
