\name{filter.PopnOL}
\alias{filter.PopnOL}
\title{  probes.filter (Internal function) }
\description{
	An internal function to be used by \code{\link{filter.probes}}
}
\usage{
filter.PopnOL(ddFILT, limPopnOL, ManuelaGO, targets, annotation.package)
}
\arguments{
  \item{ddFILT}{an RGlist object  }
  \item{limPopnOL}{for a given feature xi accros samples, is the
                maximum % of spots that can be seen
                in a experimental condition with a saturation-FLAG = 1 (Is Pop OL)  }
  \item{ManuelaGO}{ logical, if a known annotation package is available then
        it is \code{TRUE}  }
  \item{targets}{data.frame with the target structure   }
  \item{annotation.package}{ a character specifying the AGI annotation package: 'hgug4112a.db','mgug4122a.db'  }
}
\details{
	To keep good quality probes, we filtered out probes that had more than y% of the replicates 
        in at least one experimental condition with a flag indicating
        presence of Population Outlier.
        A feature is a population outlier if its signal is lower than a lower
        threshold or higher than an upper threshold determined using a multiplier
        (1.42) times the interquartile range of the population. 1 indicates
        Feature is a population outlier. 
}
\value{
	An RGlist with probes that are not Population Outlier 
        (according to the correspondind AFE flag and the filtering options).
        It also writes an output file (IsFeatPopnOL.txt) that
        contains probes that were filtered out because
        they were considered Population Outlier.
}
\author{ Pedro Lopez-Romero }
\seealso{ \code{\link{filter.probes}} }
\examples{
\dontrun{
        data(dd)
        data(targets)
	library(hgug4112a.db)
	ddFILT=filter.PopnOL(dd,25,TRUE,targets,"hgug4112a.db")
        dim(ddFILT)
}
}
\keyword{documentation}
\keyword{utilities}

