\name{filter.control}
\alias{filter.control}
\title{  filter.probes  (Internal function) }
\description{
	An internal function to be used by \code{\link{filter.probes}}
	An internal function to be used by \code{\link{CV.rep.probes}}
}
\usage{
filter.control(ddNORM, ManuelaGO, targets, annotation.package)
}
\arguments{
  \item{ddNORM}{an RGlist object }
  \item{ManuelaGO}{logical, if a known annotation package is available then
	it is \code{TRUE} }
  \item{targets}{ data.frame with the target structure }
  \item{annotation.package}{  a character specifying the AGI annotation package: 'hgug4112a.db','mgug4122a.db' }
}
\details{
	It eliminates the array internal controls
}
\value{
	An RGlist with the internal controls filtered out 
	It also writes an output file (RawDataNOCtrl.txt) that
        contains the data set with the controls filtered out and
	an output file (RawDataNOCtrlWABKGandISF.txt) that contains
	the data with the flags 'wellAboveBG' and 'IsFound'. This flags
	both take the value =1 if the signal is well above BG and Is found
	respectively. See 'filter.wellaboveBG' and 'filter.probes' 
}
\author{ Pedro Lopez-Romero }
\seealso{  \code{\link{filter.probes}} }
\examples{
\dontrun{
	data(dd)
	data(targets)
	library(hgug4112a.db)
	ddFILT=filter.control(dd,TRUE,targets,"hgug4112a.db")
	dim(ddFILT)

}
}
\keyword{documentation}
\keyword{utilities}
