\name{filter.isfound}
\alias{filter.isfound}
\title{  probes.filter (Internal function) }
\description{
	An internal function to be used by \code{\link{filter.probes}}
}
\usage{
filter.isfound(ddFILT, limISF, ManuelaGO, targets, annotation.package)
}
\arguments{
  \item{ddFILT}{  }
  \item{limISF}{for a given spot xi accros samples, is the
                minimum % of spots that is demanded to remain
                in a experimental condition with a isfound-FLAG = 1 (Is Found)  }
  \item{ManuelaGO}{logical, if a known annotation package is available then
        it is \code{TRUE}   }
  \item{targets}{data.frame with the target structure }
  \item{annotation.package}{  a character specifying the AGI annotation package: 'hgug4112a.db','mgug4122a.db' }
}
\details{
	It eliminates signals that were not found.
        The filtering is based on the FLAG given by the AFE as follows:
                For a feature = xi accross all the samples,
                we demand that at least p% of the
                spots for that feature, in at least one experimental condition, had a
                quantification flag denoting that the signal is found. 
	A spot is considered Found if two conditions
        are true: 1) the difference between spot signal and the
        local background signal is more than 1.5 times the local background
        noise and 2) the spot diameter is at least 0.30 times the nominal
        spot diameter. A Boolean variable is used to flag found features. 1 = IsFound
}
\value{
	An RGlist with probes that are found 
        (according to the correspondind AFE flag and the filtering options).
        It also writes an output file (IsNOTFound.txt) 
	that contains probes that were filtered out because
        were NOT FOUND.
}
\author{ Pedro Lopez-Romero }
\seealso{  \code{\link{filter.probes}} }
\examples{
\dontrun{
	data(dd)
        data(targets)
	library(hgug4112a.db)
	ddFILT=filter.isfound(dd,75,TRUE,targets,"hgug4112a.db")
        dim(ddFILT)
}
}
\keyword{documentation}
\keyword{utilities}

