\name{filter.saturated}
\alias{filter.saturated}
\title{  probes.filter (Internal function) }
\description{
	An internal function to be used by \code{\link{filter.probes}}
}
\usage{
filter.saturated(ddFILT, limSAT, ManuelaGO, targets, annotation.package)
}
\arguments{
  \item{ddFILT}{ an RGlist object }
  \item{limSAT}{for a given feature xi accros samples, is the
                minimum % of spots that is demanded to remain
                in a experimental condition with a saturation-FLAG = 0 (Non Saturated) }
  \item{ManuelaGO}{logical, if a known annotation package is available then
        it is \code{TRUE} }
  \item{targets}{  data.frame with the target structure }
  \item{annotation.package}{ a character specifying the AGI annotation package: 'hgug4112a.db','mgug4122a.db'  }
}
\details{
	It eliminates saturated signals. 
        The filtering is based on the FLAG given by the AFE as follows:
                For a feature = xi accross all the samples,
                we demand that at least p% of the
                spots for that feature,in at least one experimental condition, had a
                quantification flag denoting that the signal is not saturated. 
        AFE produces a Boolean flag indicating whether a spot is saturated 
        (Flag = 1) or not saturated (Flag = 0). A spot is
        saturated IF 50% of its pixels have an intensity value above the saturation
        threshold. 
}
\value{
	An RGlist with probes that are not saturated 
        (according to the correspondind AFE flag and the filtering options).
        It also writes an output file (IsSaturated.txt) that
	contains probes that were saturated. 	
}
\author{ Pedro Lopez-Romero }
\seealso{  \code{\link{filter.probes}} }
\examples{
\dontrun{
	data(dd)
        data(targets)
	library(hgug4112a.db)
        ddFILT=filter.saturated(dd,75,TRUE,targets,"hgug4112a.db")
        dim(ddFILT)

}
}
\keyword{documentation}
\keyword{utilities}

