\name{genes.rpt.agi}
\alias{genes.rpt.agi}
\title{ Genes interrogated for different probes }
\description{
	Some Genes are interrogated by different probes
	at different positions. This function identifies
	different probes interrogating the same gene.
	This group of probes is called a GENE SET. 
}
\usage{
genes.rpt.agi(dd, annotation.package, raw.data, WRITE.html, REPORT)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{dd}{ An RGList: raw data or Processed data }
  \item{annotation.package}{  a character specifying the AGI annotation package: 'hgug4112a.db','mgug4122a.db' }
  \item{raw.data}{logical, if \code{TRUE} it uses RAW data, otherwise it uses PROCESSED data }
  \item{WRITE.html}{logical, if \code{TRUE} it writes an html output }
  \item{REPORT}{logical, if \code{TRUE}it generates an information REPORT}
}
\value{
	Generates an 'html' file and a 'txt' file with information about
	genes that are interrogated for different probes at different
	chr positions. The 'html' file includes a link to the ENSEMBL data 
	base, exactly to the chr region where the 60 base agilent probe
	claims to be located. Chr coordinates are taken directly from the 
	agilent files (data files obtained after image scanning and 
	using Agilent Feature Extraction)  	
}

\author{ Pedro Lopez-Romero }
\examples{
	data(dd)
	library(hgug4112a.db)
	genes.rpt.agi(dd,"hgug4112a.db",raw.data=TRUE,
                WRITE.html=TRUE,REPORT=TRUE)

}
\keyword{documentation}
\keyword{utilities}

