\name{gsea.files}
\alias{gsea.files}
\title{ Creates files for GSEA  }
\description{
	Creates data and phenotype files for GSEA
	\url{http://www.broad.mit.edu/gsea}
}
\usage{
gsea.files(eset, targets, annotation.package)
}
\arguments{
  \item{eset}{Expression Set object containing processed DATA  }
  \item{annotation.package}{character specifying the AGI annotation package: 'hgug4112a.db','mgug4122a.db'}
  \item{targets}{data.frame with the targets structure }
}
\author{ Pedro Lopez-Romero }

\examples{
\dontrun{
	data(dd)
	data(targets)
	library(hgug4112a.db)
        selSNR=which(dd$genes$ControlType==0)
        dd.aux=dd[selSNR,]
        index=which(duplicated(dd.aux$genes$ProbeName)==FALSE)
        dd.aux=dd.aux[index,]
        eset.test=build.eset(dd.aux,targets,makePLOT=FALSE,
                annotation.package="hgug4112a.db")

	gsea.files(eset.test,targets,annotation.package="hgug4112a.db")
}
}
\keyword{documentation}
\keyword{utilities}

