\name{hierclus}
\alias{hierclus}
\title{ Hierarchical clustering  }
\description{  Hierarchical cluster of samples using the 'hclust' function
}
\usage{
hierclus(object, GErep, methdis, methclu,sel, size)
}
%- maybe also 'usage' for other objects documented here.
\arguments{
  \item{object}{ An expression Matrix }
  \item{GErep}{ Numerical vector that relates each sample with its experimental condition }
  \item{methdis}{the distance measure to be used. Options are 'euclidean' and 'pearson'.
		 see 'dist' function  }
  \item{methclu}{the agglomeration method to be used by the 'hclust' function  }
  \item{sel}{logical, if \code{TRUE} selects the 'size' highest variance genes for the plot  }
  \item{size}{selects the 'size' highest variance genes for the plot if 'sel=TRUE'  }
}
\author{ Pedro Lopez-Romero }
\seealso{ hclust,dist }
\examples{
\dontrun{
	data(dd)
	data(targets)
	GErep=targets$GErep
        selSNR=which(dd$genes$ControlType==0)
        dd.aux=dd[selSNR,]
        index=which(duplicated(dd.aux$genes$ProbeName)==FALSE)
        dd.aux=dd.aux[index,]
	hierclus(dd.aux$G,GErep,methdis="euclidean",
        methclu="complete",sel=FALSE,100)
}
}
\keyword{documentation}
\keyword{utilities}


