\name{read.targets}
\alias{read.targets}
\title{ read the target file }
\description{
	The target file is a txt file where every input file (array, sample) is
	attached to a experimental condition
}
\usage{
	read.targets(infile)
}
\arguments{
  \item{infile}{ name of the target file, for instance 'targets.txt' }
}
\details{
	Intention of data preprocessing using Agi4x44PreProces 
	is to carry out a subsequent statistical analysis
	searching for genes that are differentially expressed between different 
	experimental conditions. First, in the 'target file' we specify the 
	experimental conditions under which the data have been generated. 
        From this primary statistical analysis, one can be perform other analysis
        such as Functional Enrichment analysis, etc ...
	The target file MUST contain the following columns:
		-FileName	: Name of the array file, xxx.txt
		-Treatment	: Treatment of the file xxx.txt 
		-GErep		: Treatment of the file xxx.txt in numeric
				  code, from 'treatment-1' to 'treatment-N'  
	Other OPTIONAL columns can be
		-Subject	: If treatment are paired by 'Subject':
		-Array		: If we want to take into account that some
					samples have been hibridyzed on the
					same Agi4x44 platform 
}
\value{
	A 'data.frame' containing by columns the columns specified in 
	targets.txt 
}
\author{ Pedro Lopez-Romero }
\seealso{ read.table }
\examples{
\dontrun{
	targets=read.targets(infile="targets.txt")
}
        data(targets)
}
\keyword{documentation}
\keyword{utilities}

