\name{summarize.probe}
\alias{summarize.probe}
\title{ Replicated Probes Summarization }
\description{
	Computes Median of Replicated non-control probes 
}
\usage{
summarize.probe(ddFILT, makePLOT, targets)
}
\arguments{
  \item{ddFILT}{ RGlist, usually containing Normalized and Filtered data }
  \item{makePLOT}{LOGICAL: If True it makes graphs }
  \item{targets}{data.frame with the target structure }

}
\details{
	Normally, the Agilent 4 x 44 chips contain a set of non-control probes
	that are replicated up to ten times. These probes are spread over
	the chip and allow measuring the chip reproducibility in terms of the
	coefficient of variation (%CV). CV median is reported as the CV
        of the array. A lower CV median indicates a better reproducibility
        of the array.
	It uses an RGList as an input and it produces another
	RGList where each set of replicated non-control probes have been collapsed into a
	single value computed as the median of the probes intensities belonging
	to the same set.  
	Normally, the input RGList is the 'filtered data', but other RGList can be
	used as inputs.  
	This is an optional step. 	
}
\value{
	RGList 
}
\author{ Pedro Lopez-Romero }
\seealso{  
	\code{\link{CV.rep.probes}}
}
\examples{
\dontrun{
	data(targets)	
	data(dd)
	ddPROC=summarize.probe(dd,makePLOT=TRUE,targets)
}
}
\keyword{documentation}
\keyword{utilities}

