\name{targets}
\alias{targets}
\docType{data}
\title{ Example of target file}
\description{ Example of target file 
}
\usage{data(targets)}
\format{
  A data frame with 4 observations on the following 5 variables.
  \describe{
    \item{\code{FileName}}{names of the Files \code{Ast.txt} \code{Bst.txt} \code{Aunst.txt} \code{Bunst.txt}}
    \item{\code{Treatment}}{Assigns level for Treatment Effect to each File (mandatory)}
    \item{\code{GErep}}{a numeric vector tha numerates the FACTOR of the Treatment Effect (mandatory)}
    \item{\code{Subject}}{Assigns level for Subject Effect to each file (optional)}
    \item{\code{Array}}{Assigns level for Array Effect to each file  (optional)}
  }
}
\details{
	It is a tab-delimited text format file. 
	The target file is created with the intention of
	carrying out a differential expression analysis  
	in future steps using 'limma'. Therefore, here is where 
	factors that are going to be included in the 
	linear model that is fitted to each gen are specified. 
	Targets file assigns each image data file to one 
	of the experimental conditions of the experiment. 
	First column 'FileName' is mandatory and includes
	image data files names. Second column
	'Treatment' is also mandatory and includes treament
	effect. Third column 'GErep' is also mandatory, and
	includes the Treatment effect in a numeric code, from 
	1 to n, being n the number of Treatment effect levels.
	The rest of the columns are optional, and they 
	can include other factors that we want to specify in 
	the model, such as 'Subject', 'Array', and so on. 
}
\references{
	Gordon K. Smyth, M. Ritchie, N. Thorne, J. Wettenhall (2007). limma:
	Linear Models for Microarray Data User's Guide. 
}
\examples{
\dontrun{
	data(targets)
}
}
\keyword{datasets}
