\name{write.eset}
\alias{write.eset}
\title{ Writes the expression data matrix of an ExpressionSet object in a file }
\description{
	Writes the expression data matrix of an ExpressionSet object in a file.
}
\usage{
write.eset(eset, ddPROC, annotation.package, targets)
}
\arguments{
  \item{eset}{ An Expression object, normally containing the procesed data}
  \item{ddPROC}{An RGList object, normally containing the processed data  }
  \item{annotation.package}{ a character specifying the AGI annotation package: 'hgug4112a.db','mgug4122a.db'  }
  \item{targets}{data.frame with the targets structure }
}
\details{
	Writes the expression data matrix of an ExpressionSet object in a file.
        It also writes out the mappings of the Agilent PROBE ID with the
        ACCNUM, SYMBOL, ENTREZID and DESCRIPTION fields, using the corresponding
        annotation package
}
\author{ Pedro Lopez-Romero }
\seealso{\code{\link{build.eset}}  }
\examples{
\dontrun{
	data(dd)
	data(targets)
	library(hgug4112a.db)
        selSNR=which(dd$genes$ControlType==0)
        dd.aux=dd[selSNR,]
        index=which(duplicated(dd.aux$genes$ProbeName)==FALSE)
        dd.aux=dd.aux[index,]
        eset.test=build.eset(dd.aux,targets,makePLOT=TRUE,
                annotation.package="hgug4112a.db")
	
	write.eset(eset.test,dd.aux,"hgug4112a.db",targets)

}
}
\keyword{documentation}
\keyword{utilities}

